{* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *

Author:       Alpari Ltd

Description:  MetaTrader API for Delphi

Creation:     March 16, 2003

Version:      1.00

WWW:          http://www.alpari-idc.ru
              http://www.alpari-idc.com

EMail:        office@alpari-idc.ru
              office@alpari-idc.com

Legal issues: Copyright (C) 2002-2003 by Alpari Ltd.

              This software is provided 'as-is', without any express or
              implied warranty.  In no event will the author be held liable
              for any  damages arising from the use of this software.

              Permission is granted to anyone to use this software for any
              purpose, including commercial applications, and to alter it
              and redistribute it freely, subject to the following
              restrictions:

              1. The origin of this software must not be misrepresented,
                 you must not claim that you wrote the original software.
                 If you use this software in a product, an acknowledgment
                 in the product documentation would be appreciated but is
                 not required.

              2. Altered source versions must be plainly marked as such, and
                 must not be misrepresented as being the original software.

              3. This notice may not be removed or altered from any source
                 distribution.

 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *_*}

unit MetaTraderAPI;

{

        MetaTrader.

     MetaTrader:
1)         (, , , ,...)
2)      -    (!) .
     .
3)      -  (!)     .
     .
4)     account history.
5)             ,
   .    .

     /    . 
        (  )  
 .      .   
30     (  ?),   .
          3     
,    .        .

           .
      DoS ,    
IP .

 MetaTrader API         10 .

!   Lots   -    100.

      . ,   -         .
      -     (   )   .
       (  )  ,    100-200 .

  :
-    ,   
-     
-        -         
-    -    (    ).


     :

while (  ) do
  begin
    PARI=GetRates(symbol,period,lasttime,&total);
   ....  
   ....     
  end;


    ?     ,    
  API  .

     :

if (  ) then
  begin
    PARI=GetRates(symbol,period,lasttime,&total);
   ....  
  end
//   
....

//       
//    
case UPDATE_BIDASK:
   ...   
   ... - 
   AddTickToHistory(...); //       ,   .
   break;

     ,      .
    ,        .

 -   MetaTrader  mtapi.dll   !
MetaTrader API    ,      .
MetaTrader API -            
   .

}

interface

uses windows;

function _fromUnixTime(dt:dword):TDateTime;
function _toUnixTime(dt:TDateTime):int64;

const

   //  
   RET_OK               = 0; //  
   RET_OK_NONE          = 1; //  
   RET_ERROR            = 2; //   
   RET_INVALID_DATA     = 3; //  
   RET_TECH_PROBLEM     = 4; //    
   RET_ACCOUNT_DISABLED = 5; //  
   RET_BAD_ACCOUNT_INFO = 6;

   RET_TIMEOUT          = 7; //     
   RET_BAD_PRICES       = 8; //      
   RET_MARKET_CLOSED    = 9; //  
   RET_TRADE_DISABLE    =10; //  
   RET_NO_MONEY         =11; //     
   RET_PRICE_CHANGED    =12; //  
   RET_OFFQUOTES        =13; //  
   RET_BROKER_BUSY      =14; //  

   RET_OLD_VERSION      =15; //    
   RET_MULTI_CONNECT    =16; //  
   RET_NO_CONNECT       =17; //  
   RET_NOT_ENOUGH_RIGHTS=18; //  
   RET_BAD_STOPS        =19; //   
   RET_SKIPPED          =20; //   -    
   RET_TOO_FREQUENT     =21; //   
   RET_INVALID_VOLUME   =22; //  
   RET_INVALID_HANDLE   =23; //  
   RET_INSTANTEXECUTION =24; //    IE

   //  
   OP_BUY        = 0;
   OP_SELL       = 1;
   OP_BUY_LIMIT  = 2;
   OP_SELL_LIMIT = 3;
   OP_BUY_STOP   = 4;
   OP_SELL_STOP  = 5;
   OP_BALANCE    = 6;
   OP_CREDIT     = 7;

   //  
   PERIOD_M1     = 1;
   PERIOD_M5     = 5;
   PERIOD_M15    = 15;
   PERIOD_M30    = 30;
   PERIOD_H1     = 60;
   PERIOD_H4     = 240;
   PERIOD_D1     = 1440;
   PERIOD_W1     = 10080;

   //WPARAM  pumping
   UPDATE_BIDASK = 0;
   UPDATE_NEWS   = 1;
   UPDATE_TRADES = 2;
   UPDATE_MAIL   = 3;
   END_PUMPING   = 4;

   //    (   instant execution)
   EXE_REQUEST   = 0;
   EXE_MARKET    = 1;

   MAX_PATH =1000;

   //   
   MaxRateInfoCount = 32768; //      
   MaxNewsTopicCount = 256;  //    
   MaxTradeRecordCount = 256; //    (    )
   MaxTickInfoCount = 256; // - ,      bid-ask
   MaxConSecurityCount = 256;  // - ,      

type

  time_t    = Longword;

  PRateInfo = ^TRateInfo;

  TRateInfo = packed record   //   
   ctm          :  time_t;    //    
   open         :  double;
   low          :  double;
   high         :  double;
   close        :  double;
   vol          :  integer;
  end;

  PARateInfo = ^TARateInfo;
  TARateInfo = array [0..MaxRateInfoCount] of TRateInfo;

  PNewsTopic = ^TNewsTopic;

  TNewsTopic = packed record
   ctm          :array [0..19] of char;    //    "yyyy/mm/dd hh:mm:ss"
   topic        :array [0..255] of char;   // 
   keywords     :array [0..255] of char;   //  
   len          :integer;                  //  
   body         :pchar;                    //   ( )
   key          :integer;                  //   
   newkey       :integer;                  //   
  end;

  PANewsTopic = ^TANewsTopic;
  TANewsTopic = array [0..MaxNewsTopicCount] of TNewsTopic;

  PBriefUserInfo = ^TBriefUserInfo;

  TBriefUserInfo = packed record
   login        :integer;                  // 
   isdemo       :integer;                  // ?
   name         :array [0..63] of char;    // 
   company      :array [0..63] of char;    // 
   balance      :double;                   // 
   equity       :double;                   // equity
   credit       :double;                   // 
   margin       :double;                   // 
   freemargin   :double;                   //  
   profit       :double;                   // 
   marginmode   :integer;                  //
   margincall   :integer;                  //  
   margintype   :char;                     //   0-%,1-$
   allow_flags  :integer;                  //  
   leverage     :integer;
  end;

  PSendOrderInfo = ^TSendOrderInfo;

  TSendOrderInfo = packed record
   req_code     :char;                 //    
   order        :integer;              // 
   symbol       :array [0..7] of char; // 
   volume       :integer;              //  ( ,   100)
   cmd          :byte;                 //  OP_BUY....OP_SELL_STOP
   price        :double;               //  
   sl           :double;               // StopLoss
   tp           :double;               // TakeProfit
   crc          :integer;              //  
  end;

  PDemoAccountInfo = ^TDemoAccountInfo;

  TDemoAccountInfo = record
   login      : integer;                 //   
   password   :array [0..15] of char;    //   
   phonepassword:array [0..15] of char;
   name       :array[0..63] of char;     // 
   group      :array[0..15] of char;     // 
   country    :array[0..31] of char;     // 
   city       :array[0..31] of char;     // 
   state      :array[0..31] of char;     // 
   zipcode    :array[0..15] of char;     // 
   address    :array[0..31] of char;     // 
   phone      :array[0..31] of char;     // 
   email      :array[0..31] of char;     // 
   unused     :array[0..71] of char;
   leverage   :integer;                  // 
   balance    :double;                   // 
   reserved   :array[0..19] of char;
  end;

  PTradeRecord = ^TTradeRecord;

  TTradeRecord = record
   order        :integer;              //  
   login        :integer;              //  
   symbol       :array [0..7] of char; // 
   digits       :short;                // -   
   cmd          :short;                // 
   volume       :integer;              // 
   open_time    :time_t;               //  
   open_price   :double;               //  
   close_time   :time_t;               //  
   close_price  :double;               //  
   sl           :double;
   tp           :double;               // StopLoss TakeProfit
   commission   :double;               // 
   agent_commission:double;            //  ,
   storage      :double;               // 
   profit       :double;               // 
   comment      :array[0..31]of char;  // 
  end;

  PATradeRecord = ^TATradeRecord;
  TATradeRecord = array [0..MaxTradeRecordCount] of TTradeRecord;

  PTickInfo = ^TTickInfo;

  TTickInfo = record          //  
   ctm          :time_t;                 // 
   symbol       :array[0..7] of char;    //  
   bid          :double;                 //  bid
   ask          :double;                 //  ask
  end;

  PATickInfo = ^TATickInfo;
  TATickInfo = array [0..MaxTickInfoCount] of TTickInfo;

  PConSession = ^TConSession;

  TConSession = record
   open_hour     :short;
   open_min      :short;
   close_hour    :short;
   close_min     :short;
   open_hour2    :short;
   open_min2     :short;
   close_hour2   :short;
   close_min2    :short;
   open_hour3    :short;
   open_min3     :short;
   close_hour3   :short;
   close_min3    :short;
   open          :integer;
   close         :integer;             //    
   open2         :integer;
   close2        :integer;             //    
   open3         :integer;
   close3        :integer;             //    
  end;

  PConSecurity = ^TConSecurity;

  TConSecurity = record
   name          :array[0..7] of char;            // 
   description   :array[0..63] of char;           // 
   source        :array[0..7] of char;            //    
   secname       :array[0..15] of char;           //   
   typesec       :integer;                        //  
   logging       :integer;                        //   
   indirect      :integer;                        //   
   filter        :integer;                        //   (  1,  )
   trade         :integer;                        //   
   spread        :integer;                        //  
   exemode       :integer;                        //  
   count         :integer;                        //
   realtime      :integer;                        //    
   swap_type     :integer;                        //  
   slong         :double;
   sshort        :double;                         //   
   digits        :integer;                        // -   
   contract      :double;                         //  
   margin_mode   :integer;                        //   
   initialmargin :double;                         //  
   maintenance   :double;                         //   
   hedged        :double;                         //     
   margin_divider:double;                         //  
   point         :double;                         //   1/pow(10,floats)
   multiply      :double;                         //   pow(10,floats)
   stops         :integer;                        //   
   tickvalue     :double;                         //     
   tickvalue2    :double;                         //    
   ticksize      :double;                         //   
   starting      :time_t;                         //   
   expiration    :time_t;                         //   
   days          :array[0..6] of TConSession;     //     
   unused        :array[0..15] of integer;        // 
   next          :PConSecurity;                   //    
  end;

  PAConSecurity = ^TAConSecurity;
  TAConSecurity = array [0..MaxConSecurityCount] of TConSecurity;

  PMailBoxHeader = ^TMailBoxHeader;

  TMailBoxHeader = record
   time          :time_t;                        //  
   from          :array[0..63] of char;          //  
   mailto            :integer;                       // 
   subject       :array[0..127] of char;         // 
   readed        :integer;                       //  
  end;

  TMtCreate              = function (): integer; cdecl;
  TMtConnect             = function (const handle: integer; const server: PChar; const port: integer): integer; cdecl;
  TMtLogin               = function (const handle:integer; const login:integer; const password:PChar): integer; cdecl;
  TMtDelete              = function (const handle:integer): integer; cdecl;
  TMtDisconnect          = function (const handle:integer): integer; cdecl;
  TMtOpenDemoAccount     = function (const handle:integer; info:PDemoAccountInfo): integer; cdecl;
  TMtChangePassword      = function (const handle:integer; const newpass:pchar): integer; cdecl;
  TMtGetPrices           = function (const handle:integer; const symbol:pchar; const lots:integer; bid, ask:pdouble): integer; cdecl;
  TMtSendOrder           = function (const handle:integer; const soi:PSendOrderInfo): integer; cdecl;
  TMtGetErrorDescription = function (const errorcode:integer): pchar; cdecl;
  TMtSetWorkingDirectory = function (const path:pchar): integer; cdecl;
  TMtSetPumpingMode      = function (const handle:integer; const destwnd:HWND; const eventmsg:UINT): integer; cdecl;
  TMtGetTrades           = function (const handle: integer ): integer; cdecl;
  TMtGetTradeRecords     = function (const handle: integer; bui: PBriefUserInfo; items: PInteger): PATradeRecord; cdecl;
  TMtGetRates            = function (const handle:integer; const symbol:pchar; const period:integer; const lasttime:time_t ; counter:pinteger ): PARateInfo; cdecl;
  TMtAddSymbol           = function (const handle:integer; const symbol:pchar ): integer; cdecl;
  TMtRefreshSecurities   = function (const handle:integer): integer; cdecl;
  TMtGetTradeHistory     = function (const handle:integer; const fromtime:time_t; const totime:time_t; items:pinteger):PATradeRecord; cdecl;
  TMtGetNewsBody         = function (const handle:integer; const key:integer):pchar; cdecl;
  TMtDeleteOrder         = function (const handle:integer; const order:integer): integer; cdecl;
  TMtModifyOrder         = function (const handle:integer; const order:integer; const price:double; const sl:double; const tp:double): integer; cdecl;
  TMtCloseOrder          = function (const handle:integer; const order:integer; const price:double; const volume:integer): integer; cdecl;
  TMtCloseByOrder        = function (const handle:integer; const order:integer; const byorder:integer): integer; cdecl;
  TMtGetSecurities       = function (const handle:integer; items:pinteger):PAConSecurity; cdecl;
  TMtHideSymbol          = function (const handle:integer; const symbol:pchar): integer; cdecl;
  TMtGetUpdatedTickInfo  = function (const handle:integer; items:pinteger):PATickInfo; cdecl;
  TMtGetLastMail         = function (const handle:integer; path:pchar; lenofpath:pinteger): integer; cdecl;
  TMtGetLastNews         = function (const handle:integer; pitems:pinteger):PANewsTopic; cdecl;

  //***********************************************************************************//

  TMTApi = class
    protected
    private
      hLib: HWND; //  

      MtCreate:                 TMtCreate;
      MtConnect:                TMtConnect;
      MtLogin:                  TMtLogin;
      MtDelete:                 TMtDelete;
      MtDisconnect:             TMtDisconnect;
      MtOpenDemoAccount:        TMtOpenDemoAccount;
      MtChangePassword:         TMtChangePassword;
      MtGetPrices:              TMtGetPrices;
      MtSendOrder:              TMtSendOrder;
      MtGetErrorDescription:    TMtGetErrorDescription;
      MtSetWorkingDirectory:    TMtSetWorkingDirectory;
      MtSetPumpingMode:         TMtSetPumpingMode;
      MtGetTrades:              TMtGetTrades;
      MtGetTradeRecords:        TMtGetTradeRecords;
      MtGetRates:               TMtGetRates;
      MtAddSymbol:              TMtAddSymbol;
      MtRefreshSecurities:      TMtRefreshSecurities;
      MtGetTradeHistory:        TMtGetTradeHistory;
      MtGetNewsBody:            TMtGetNewsBody;
      MtDeleteOrder:            TMtDeleteOrder;
      MtModifyOrder:            TMtModifyOrder;
      MtCloseOrder:             TMtCloseOrder;
      MtCloseByOrder:           TMtCloseByOrder;
      MtGetSecurities:          TMtGetSecurities;
      MtHideSymbol:             TMtHideSymbol;
      MtGetUpdatedTickInfo:     TMtGetUpdatedTickInfo;
      MtGetLastMail:            TMtGetLastMail;
      MtGetLastNews:            TMtGetLastNews;

    public
     WM_MetaTraderAPIPumpingMessage: cardinal;
     constructor Create;
     destructor  Destroy; override;

     //  ,     log-, 
     //  ,      .   
     //   .      NULL,
     //     ,    exe- 
     //(     ,  mtapi.dll.).
     //path -    (  ).
     //  .
     {+}function SetWorkingDirectory(path:string):integer;

     //       MetaTrader.
     //    (  )   .
     // -1   .      
     // .
     {+}function CreateSocket:integer;

     //    .
     //    ,      .
     //  .
     {+}function DeleteSocket(const handle:integer):integer;

     //   
     //handle -  ,     ;
     //server -    (IP-address  domain name);
     //port -  .  MetaTrader  -  1950.
     //  .
     {+}function Connect(const handle:integer; const server:string; const port:integer):integer;

     //     .      .
     //  .
     {+}function Disconnect(const handle:integer):integer;

     //       .
     //handle -  ,       ;
     //login -   (  ,    );
     //password -     .
     //  .
     {+}function Login(const handle:integer; const login:integer; const password:string):integer;

     //     ()   
     //    .        
     //         login  password 
     //DemoAccountInfo   pdai
     //handle -  ,       ;
     //  .
     {+}function OpenDemoAccount(const handle:integer; pdai:PDemoAccountInfo):integer;

     //     .
     //handle -  ,          
     //              ;
     //newpassword -       .
     //  .
     {+}function ChangePassword(const handle:integer; const newpassword:pchar):integer;

     //     .     
     //RateInfo    *counter,  NULL   .
     //        HeapFree.
     //handle -  ,           ;
     //symbol -  ,     ;
     //period -  .  : PERIOD_M1, PERIOD_M5, PERIOD_M15,
     //         PERIOD_M30, PERIOD_H1, PERIOD_H4, PERIOD_D1, PERIOD_W1 (  , ,.., )
     //lasttime - ,     
     //pcounter -    integer,      .
     {+}function GetRates(const handle:integer; const symbol:string; const period:integer; const lasttime:TDateTime;pcounter:pinteger):PARateInfo;

     //      .
     //handle -  ,           .
     //  .
     {+}function GetTrades(const handle:integer):integer;

     //     TradeRecord,    .
     //         HeapFree.
     //handle -  ,           ;
     //pbui -     BriefUserInfo,      ;
     //pitems -    int,      .
     {+}function GetTradeRecords(const handle:integer; pbui:PBriefUserInfo; pitems:pinteger):PATradeRecord;

     //      .
     //     TradeRecord,    .  NULL   .
     //         HeapFree.
     //handle -  ,           ;
     //from, to -  ,          .
     //pitems -    integer,      .
     {+}function GetTradeHistory(const handle:integer; const from:TDateTime; const totime:TDateTime; pitems:pinteger):PATradeRecord;

     //        (key).
     //  ,  ,  NULL   .
     //,         HeapFree.
     //handle -  ,           ;
     //key -  .
     {+}function GetNewsBody(const handle:integer; const key:integer):pchar;

     //          .
     //handle -  ,           ;
     //symbol -  ,     ;
     //lots -  ,   100;
     //pbid -    double,      bid;
     //pask -    double,      ask;
     // .  ,    ,
     //   Instant Execution,      ,
     //    RET_INSTANTEXECUTION.    
     //      . 
     //   ,    ,  
     //  ,     
     //    AddSymbol.   ,
     //    Instant Execution.   
     //ConSecurity,      GetSecurities,
     //     exemode  EXE_MARKET.
     //  .
     {+}function GetPrices(const handle:integer; const symbol:string; const lots:integer; pbid,pask:pdouble):integer;

     //        "" .
     //        GetTrades  GetTradeRecords.
     //        ,    
     //       GetTradeRecords
     //(   GetTrades!).
     //handle -  ,           ;
     //psoi -     SendOrderInfo,       .
     //  .
     {+}function SendOrder(const handle:integer; const psoi:PSendOrderInfo):integer;

     //    <> .
     //handle -  ,           ;
     //order -   .
     //  .
     {+}function DeleteOrder(const handle:integer; const order:integer):integer;

     //     .
     //handle -  ,           ;
     //order -  ;
     //price -   ;
     //sl -   Stop Loss;
     //tp -   Take Profit.
     //  .
     {+}function ModifyOrder(const handle:integer; const order:integer; const price:double; const sl:double; const tp:double):integer;

     //    .
     //handle -  ,           ;
     //order -  ;
     //price - ;
     //volume -   
     //        (    -      ).
     //  .
     {+}function CloseOrder(const handle:integer; const order:integer; const price:double; const volume:integer):integer;

     //           
     // ,   .
     //handle -  ,           ;
     //order -   ;
     //byorder -   .
     //  .
     {+}function CloseByOrder(const handle:integer; const order:integer; const byorder:integer):integer;

     //      .
     //     securities.dat,    .
     //         
     //    .     
     // ,            GetSecurities.
     //handle -  ,           .
     //  .
     {+}function RefreshSecurities(const handle:integer):integer;

     //   .
     //handle -  ,           ;
     //pitems -    integer,      .
     //     ConSecurity,    .
     //         HeapFree.
     {+}function GetSecurities(const handle:integer; pitems:pinteger):PAConSecurity;

     //          
     // .       .
     //handle -  ,           ;
     //symbol -   .
     //  .
     {+}function AddSymbol(const handle:integer; const symbol:string):integer;

     //            .
     //handle -  ,           ;
     //symbol -   .
     //  .
     {+}function HideSymbol(const handle:integer; const symbol:string):integer;

     //         ( ).
     //    ,     
     //     ,   .  
     //     - , , 
     //  ,   .
     //!          
     //      ,      Disconnect.
     //   : GetTradeRecords, GetSecurities, AddSymbol,
     //HideSymbol, GetUpdatedTickInfo, GetLastNews, GetLastMail.
     //    GetPrices,     , 
     //     Instant Execution!
     //handle -  ,           ;
     //destwnd -  ,          ;
     //eventmsg -  ,    .
     //   WPARAM      :
     //UPDATE_BIDASK, UPDATE_NEWS, UPDATE_TRADES, UPDATE_MAIL  END_PUMPING.
     //   LPARAM    ,  .
     //  .
     {+}function SetPumpingMode(const handle:integer; const destwnd:HWND; const eventmsg:UINT):integer;

     //   .     
     //UPDATE_BIDASK.        ,   
     //       ,    
     // ,    .
     //handle -  ,           ;
     //pitems -    int,     .
     //     TickInfo,   .
     //        HeapFree.
     {+}function GetUpdatedTickInfo(const handle:integer; pitems:pinteger):PATickInfo;

     //   .     UPDATE_ NEWS.
     //        ,  
     //   ,    .
     //handle -  ,           ;
     //pitems -    int,     .
     //     NewsTopic,   .
     //        HeapFree.
     {+}function GetLastNews(const handle:integer; pitems:pinteger):PANewsTopic;

     //  ,        .
     //handle -  ,           ;
     //path -     ;
     //  .
     {+}function GetLastMail(const handle:integer; var path:string):integer;

     //   .      
     {+}function GetErrorDescription(const errorcode:integer):string;
  end;

implementation

uses winsock;

function _fromUnixTime(dt:dword):TDateTime;
begin
  result:=25569+(dt div (60*60*24))+(dt mod (60*60*24))/(60*60*24);
end;

function _toUnixTime(dt:TDateTime):int64;
begin
   Result:=round(60*60*24*(dt-25569));
end;

constructor TMTApi.Create;
var  wVersionRequired: word;
     WSData:TWSAData;
begin
  WM_MetaTraderAPIPumpingMessage := RegisterWindowMessage('MetaTraderAPI_Pumping_Message');

  // winsock
  wVersionRequired := $0101;
  WSAStartup(wVersionRequired, WSData );

  //    
  hLib := LoadLibrary('mtapi.dll');

  @MtCreate :=GetProcAddress(hLib,PChar('MtCreate'));
  @MtConnect := GetProcAddress(hLib,PChar('MtConnect'));
  @MtLogin := GetProcAddress(hLib,PChar('MtLogin'));
  @MtDelete := GetProcAddress(hLib,PChar('MtDelete'));
  @MtGetTrades := GetProcAddress(hLib,PChar('MtGetTrades'));
  @MtGetTradeRecords := GetProcAddress(hLib,PChar('MtGetTradeRecords'));
  @MtDisconnect := GetProcAddress(hLib,PChar('MtDisconnect'));
  @MtOpenDemoAccount:= GetProcAddress(hLib,PChar('MtOpenDemoAccount'));
  @MtChangePassword:= GetProcAddress(hLib,PChar('MtChangePassword'));
  @MtGetPrices:= GetProcAddress(hLib,PChar('MtGetPrices'));
  @MtSendOrder:= GetProcAddress(hLib,PChar('MtSendOrder'));
  @MtGetErrorDescription:= GetProcAddress(hLib,PChar('MtGetErrorDescription'));
  @MtSetWorkingDirectory:= GetProcAddress(hLib,PChar('MtSetWorkingDirectory'));
  @MtGetRates:= GetProcAddress(hLib,PChar('MtGetRates'));
  @MtSetPumpingMode:=GetProcAddress(hLib,PChar('MtSetPumpingMode'));
  @MtAddSymbol:=GetProcAddress(hLib,PChar('MtAddSymbol'));
  @MtRefreshSecurities:=GetProcAddress(hLib,PChar('MtRefreshSecurities'));
  @MtGetTradeHistory:=GetProcAddress(hLib,PChar('MtGetTradeHistory'));
  @MtGetNewsBody:=GetProcAddress(hLib,PChar('MtGetNewsBody'));
  @MtDeleteOrder:=GetProcAddress(hLib,PChar('MtDeleteOrder'));
  @MtModifyOrder:=GetProcAddress(hLib,PChar('MtModifyOrder'));
  @MtCloseOrder:=GetProcAddress(hLib,PChar('MtCloseOrder'));
  @MtCloseByOrder:=GetProcAddress(hLib,PChar('MtCloseByOrder'));
  @MtGetSecurities:=GetProcAddress(hLib,PChar('MtGetSecurities'));
  @MtHideSymbol:=GetProcAddress(hLib,PChar('MtHideSymbol'));
  @MtGetUpdatedTickInfo:=GetProcAddress(hLib,PChar('MtGetUpdatedTickInfo'));
  @MtGetLastMail:=GetProcAddress(hLib,PChar('MtGetLastMail'));
  @MtGetLastNews:=GetProcAddress(hLib,PChar('MtGetLastNews'));

end;

destructor  TMTApi.Destroy; 
begin
  WSACleanup();
  FreeLibrary(hLib);
  inherited Destroy;
end;

function TMTApi.SetWorkingDirectory(path:string):integer;
begin
  result:=MtSetWorkingDirectory(pchar(path));
end;

function TMTApi.CreateSocket:integer;
begin
  Result:=MtCreate();
end;

function TMTApi.DeleteSocket(const handle:integer):integer;
begin
  Result:=MtDelete(handle);
end;

function TMTApi.Connect(const handle:integer; const server:string; const port:integer):integer;
begin
  Result:=MtConnect(handle,PChar(server),port);
end;

function TMTApi.Disconnect(const handle:integer):integer;
begin
  Result:=MtDisconnect(handle);
end;

function TMTApi.Login(const handle:integer; const login:integer; const password:string):integer;
begin
  Result:=MtLogin(handle,login,PChar(password));
end;

function TMTApi.OpenDemoAccount(const handle:integer; pdai:PDemoAccountInfo):integer;
begin
  Result:=MtOpenDemoAccount(handle,pdai);
end;

function TMTApi.ChangePassword(const handle:integer; const newpassword:pchar):integer;
begin
  Result:=MtChangePassword(handle,newpassword);
end;

function TMTApi.GetRates(const handle:integer; const symbol:string; const period:integer; const lasttime:TDateTime;pcounter:pinteger):PARateInfo;
begin
  Result:=MtGetRates(handle, pchar(symbol),period,_tounixtime(lasttime),pcounter);
end;

function TMTApi.GetTrades(const handle:integer):integer;
begin
  Result:=MtGetTrades(handle);
end;

function TMTApi.GetTradeRecords(const handle:integer; pbui:PBriefUserInfo; pitems:pinteger):PATradeRecord;
begin
  Result:=MtGetTradeRecords(handle, pbui, pitems);
end;

function TMTApi.GetTradeHistory(const handle:integer; const from:TDateTime; const totime:TDateTime; pitems:pinteger):PATradeRecord;
begin
  Result:=MtGetTradeHistory(handle, _tounixtime(from), _tounixtime(totime), pitems);
end;

function TMTApi.GetNewsBody(const handle:integer; const key:integer):pchar;
begin
  Result:=MtGetNewsBody(handle,key);
end;

function TMTApi.GetPrices(const handle:integer; const symbol:string; const lots:integer; pbid,pask:pdouble):integer;
begin
  Result:=MtGetPrices(handle,pchar(symbol),lots,pbid,pask);
end;

function TMTApi.SendOrder(const handle:integer; const psoi:PSendOrderInfo):integer;
begin
  Result:=MtSendOrder(handle,psoi);
end;

function TMTApi.DeleteOrder(const handle:integer; const order:integer):integer;
begin
  Result:=MtDeleteOrder(handle,order);
end;

function TMTApi.ModifyOrder(const handle:integer; const order:integer; const price:double; const sl:double; const tp:double):integer;
begin
  Result:=MtModifyOrder(handle,order,price,sl,tp);
end;

function TMTApi.CloseOrder(const handle:integer; const order:integer; const price:double; const volume:integer):integer;
begin
  Result:=MtCloseOrder(handle,order,price,volume);
end;

function TMTApi.CloseByOrder(const handle:integer; const order:integer; const byorder:integer):integer;
begin
  Result:=MtCloseByOrder(handle,order,byorder);
end;

function TMTApi.RefreshSecurities(const handle:integer):integer;
begin
  Result:=MtRefreshSecurities(handle);
end;

function TMTApi.GetSecurities(const handle:integer; pitems:pinteger):PAConSecurity;
begin
  Result:=MtGetSecurities(handle,pitems);
end;

function TMTApi.AddSymbol(const handle:integer; const symbol:string):integer;
begin
  Result:=MtAddSymbol(handle,pchar(symbol));
end;

function TMTApi.HideSymbol(const handle:integer; const symbol:string):integer;
begin
  Result:=MtHideSymbol(handle,pchar(symbol));
end;

function TMTApi.SetPumpingMode(const handle:integer; const destwnd:HWND; const eventmsg:UINT):integer;
begin
  Result:=MtSetPumpingMode(handle,destwnd,eventmsg);
end;

function TMTApi.GetUpdatedTickInfo(const handle:integer; pitems:pinteger):PATickInfo;
begin
  Result:=MtGetUpdatedTickInfo(handle,pitems);
end;

function TMTApi.GetLastNews(const handle:integer; pitems:pinteger):PANewsTopic;
begin
  Result:=MtGetLastNews(handle,pitems);
end;

function TMTApi.GetLastMail(const handle:integer; var path:string):integer;
var p:array [0..MAX_PATH-1] of char;
    r,i:integer;
begin
  i:=MAX_PATH;
  r:=MtGetLastMail(handle,p,@i);
  path:='';
  path:=(string(p));
  Result:=r;
end;

function TMTApi.GetErrorDescription(const errorcode:integer):string;
begin
   Result:=string(MtGetErrorDescription(errorcode));
end;

end.
